<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <title>文本溢出-多文本溢出省略（按行数）-JS实现</title>
    <style>
    </style>
</head>

<body>
    <div class="wrap"></div>
    <script>
        const text =
            '文本溢出-多文本溢出省略（按行数）文本溢出-多文本溢出省略（按行数）文本溢出-多文本溢出省略（按行数）文本溢出-多文本溢出省略（按行数）文本溢出-多文本溢出省略（按行数）文本溢出-多文本溢出省略（按行数）文本溢出-多文本溢出省略（按行数）文本溢出-多文本溢出省略（按行数）文本溢出-多文本溢出省略（按行数）';
        const totalTextLen = text.length;
        const formatStr = () => {
            const ele = document.getElementsByClassName('wrap')[0];
            const lineNum = 2;
            const baseWidth = window.getComputedStyle(ele).width;
            const baseFontSize = window.getComputedStyle(ele).fontSize;
            const lineWidth = +baseWidth.slice(0, -2);
            // 所计算的strNum为元素内部一行可容纳的字数(不区分中英文)
            const strNum = Math.floor(lineWidth / +baseFontSize.slice(0, -2));
            let content = '';
            // 多行可容纳总字数
            const totalStrNum = Math.floor(strNum * lineNum);

            const lastIndex = totalStrNum - totalTextLen;

            if (totalTextLen > totalStrNum) {
                content = text.slice(0, lastIndex - 3).concat('...');
            } else {
                content = text;
            }
            ele.innerHTML = content;
        }

        formatStr();
        window.onresize = () => {
            formatStr();
        };
    </script>
</body>

</html>